<?php
namespace JHodges\GiteaBotPHPUnit;

use \JHodges\GiteaBot\Client;

final class Poster{

  private $report;

  function __construct($testdox_path,$xml_path){
    $testdox=file_get_contents($testdox_path);
    $testdox=preg_replace('# \[#',' * [',$testdox);

    $this->report.=$testdox;

    $this->xml = simplexml_load_file($xml_path);
  }

  public function post($url, $user, $pass, $repoUser, $repo, $title='Test Results'){
    // open connection and repo
    $this->client=new Client($url, $user, $pass);
    $this->repo=$this->client->getRepo($repoUser, $repo);

    $this->process($this->xml); //process xml and upload screenshots

    // create the issue
    $issue=$this->repo->createIssue([
      'title'=>$title,
      'body'=>$this->report
    ]);

  }

  private function process($item){
    if(isset($item->testcase)){
      foreach($item->testcase as $testcase) {
        foreach($testcase as $k=>$v){
          $img='';
          $name=$testcase->attributes()->class[0]."::".$testcase->attributes()->name[0];
          if(file_exists("/tmp/$name.png")){
            $data=$this->repo->addAttachment("/tmp/$name.png");
            $url=$data->browser_download_url;
            $img="\n![]($url)\n";
            unlink("/tmp/$name.png");
          }
          $this->report.="\n------\n# $name\n$img\n```plain\n".print_r($testcase,true)."\n```";
        }
      }
    }
    if(isset($item->testsuite)){
      foreach($item->testsuite as $testsuite) {
        $this->process($testsuite);
      }
    }
  }

}
